HDU 1690:Bus System

Bus System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 8469    Accepted Submission(s): 2273

点击打开题目链接
Problem Description
Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it’s still playing an important role even now.
The bus system of City X is quite strange. Unlike other city’s system, the cost of ticket is calculated based on the distance between the two stations. Here is a list which describes the relationship between the distance and the cost.



Your neighbor is a person who is a really miser. He asked you to help him to calculate the minimum cost between the two stations he listed. Can you solve this problem for him?
To simplify this problem, you can assume that all the stations are located on a straight line. We use x-coordinates to describe the stations’ positions.
 

Input
The input consists of several test cases. There is a single number above all, the number of cases. There are no more than 20 cases.
Each case contains eight integers on the first line, which are L1, L2, L3, L4, C1, C2, C3, C4, each number is non-negative and not larger than 1,000,000,000. You can also assume that L1<=L2<=L3<=L4.
Two integers, n and m, are given next, representing the number of the stations and questions. Each of the next n lines contains one integer, representing the x-coordinate of the ith station. Each of the next m lines contains two integers, representing the start point and the destination.
In all of the questions, the start point will be different from the destination.
For each case,2<=N<=100,0<=M<=500, each x-coordinate is between -1,000,000,000 and 1,000,000,000, and no two x-coordinates will have the same value.
 

Output
For each question, if the two stations are attainable, print the minimum cost between them. Otherwise, print “Station X and station Y are not attainable.” Use the format in the sample.
 

Sample Input
  
  
2 1 2 3 4 1 3 5 7 4 2 1 2 3 4 1 4 4 1 1 2 3 4 1 3 5 7 4 1 1 2 3 10 1 4
 

Sample Output
  
  
Case 1: The minimum cost between station 1 and station 4 is 3. The minimum cost between station 4 and station 1 is 3. Case 2: Station 1 and station 4 are not attainable.
 
题目意思:
给出各个长度和花费,然后给出n,m, 接下来n行每行一个数,代表0到城市i的距离。注意这些城市是在一条直线上的。然后询问m个城市间的最小花费。
解题思路:
题目最多给出100个城市,最多有20个组测试数据。而且随机询问m个城市的最短路径,说明我们一定要先求出两两城市间的最短路径。这种问题一般最适合
用Flody求解,主要看数据规模。Flody是的时间复杂度为立方阶。然后最多100个城市,Flody一次100*100*100,加上20组测试数据,20*100*100*100.是极限
情况,也不大,就用Flody去解。题目的坑的地方是数太大了。要用__int64,和其他人一样,因为这个会错好多次。因为第一想用long long,可以是long long也是
不行的。

#include<iostream>
#include<cstdio>
#include<queue>
#include<vector>
#include<cstring>
#include<stack>
#define INF 1e18
#define MAXN 10003

using namespace std;

__int64 Map[102][102];  ///存放地图
int n,m;   ///n个站点,m个问题
__int64 L1,L2,L3,L4,C1,C2,C3,C4;
__int64 dis[102]; ///存放0到每个车站的距离,这些车站都在一条线上
///求绝对值的函数
__int64 fun(__int64 num)
{
    return num<0? -num:num;
}
void InitMap()
{
    for(int i = 1; i <= n; i++)
    {
        Map[i][i] = 0;
        for(int j = i+1; j <= n; j++)
        {
            __int64 temp = fun(dis[j]-dis[i]); ///求相对距离,因为所有城市在同一条直线上
            if(temp>0 && temp<=L1)
                Map[i][j] = Map[j][i] = C1;
            else if(temp <= L2)
                Map[i][j] = Map[j][i] = C2;
            else if(temp <= L3)
                Map[i][j] = Map[j][i] = C3;
            else if(temp <= L4)
                Map[i][j] = Map[j][i] = C4;
            else
                Map[i][j] = Map[j][i] = INF;
        }
    }
}
void Flody()
{
    for(int k = 1; k <= n; k++)
        for(int i = 1; i <= n; i++)
            for(int j = 1; j <= n; j++)
                if(Map[i][k]+Map[k][j] < Map[i][j])
                    Map[i][j] = Map[i][k]+Map[k][j];
}
int main()
{
    int T,t=0;
    scanf("%d",&T);         //T组测试数据
    while(T--)
    {

        scanf("%I64d%I64d%I64d%I64d%I64d%I64d%I64d%I64d",&L1,&L2,&L3,&L4,&C1,&C2,&C3,&C4);
        scanf("%d%d",&n,&m);
        for(int i = 1; i <= n; i++)
            scanf("%I64d",&dis[i]);
        InitMap();
        Flody();
        printf("Case %d:\n",++t);
        int s,e;
        while(m--)
        {
            scanf("%d%d",&s,&e);
            if(Map[s][e]<INF)
                printf("The minimum cost between station %d and station %d is %I64d.\n",s,e,Map[s][e]);
            else
                printf("Station %d and station %d are not attainable.\n",s,e);
        }
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值